//***************** (c) 2012 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : GPS Quectel L50
// BOARD    : ZL27ARM and GPS Quectel L50
// COMPILER : Keil uVision4.5
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple read GPS position.
//
//    Settings and connections from ZL27ARM to GPS Quectel L50 and Oled 2x20:
//
//							
//				ZL27ARM +3.3V(JP6) - GPS Quectel L50 pin9(con1)
//				ZL27ARM GND  (JP6) - GPS Quectel L50 pin2(con1)
//        ZL27ARM PA10 (JP6) - GPS Quectel L50 pin1(con1)
//
//
//							KAmodLED8 B
//				ZL27ARM +3.3V(JP8) - Oled 2x20 +V (con1)
//				ZL27ARM GND  (JP8) - Oled 2x20 GND(con1)
//				ZL27ARM PD0  (JP8) - Oled 2x20 D0(pin7)
//				ZL27ARM PD1  (JP8) - Oled 2x20 D1(pin8)
//				...
//				ZL27ARM PD7  (JP8) - Oled 2x20 D7(pin14)
//				ZL27ARM PD8  (JP8) - Oled 2x20 RS(pin4)
//				ZL27ARM PD9  (JP8) - Oled 2x20 RW(pin5)
//				ZL27ARM PD10  (JP8) - Oled 2x20 E(pin6)
//        
//
//******************************************************************************

#include "stm32f10x.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#include ".\..\Moduly\LCD_8bit_oled\lcd_hd44780_lib.h"

char N[15];
char E[13];
char temp[5];
char Nm[3];
char Ns[5];
float fLiczba=0.0;

uint8_t i;
char GPGGA[] = "GPGGA";
void RCC_Conf(void);
void NVIC_Conf(void);
void GPIO_Conf(void);
void PrzeliczN(void);


//Odbior pojedynczego znaku
char getch(void)
{
	char tmp;
	while(USART_GetFlagStatus(USART1, USART_FLAG_RXNE) == RESET);
	tmp = USART_ReceiveData(USART1); 
	return tmp;	
}

int main(void)
{
	  USART_InitTypeDef USART_InitStructure;
	  GPIO_InitTypeDef GPIO_InitStructure;


  	RCC_Conf(); NVIC_Conf();

  	// Konfiguracja PA10 jako Rx
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
		// Konfiguracja USART
  	USART_InitStructure.USART_BaudRate = 4800;																					//Predkosc transnisji 9600
  	USART_InitStructure.USART_WordLength = USART_WordLength_8b;													//dlugosc paczki 8bit
  	USART_InitStructure.USART_StopBits = USART_StopBits_1;															//Stop bit 1
  	USART_InitStructure.USART_Parity = USART_Parity_No;																	//Pazystosc brak
  	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;			//Sterowanie przeplywem brak
  	USART_InitStructure.USART_Mode = USART_Mode_Rx;																			//Odczytywanie
		USART_Init(USART1, &USART_InitStructure);																						//Zapisz ustawienia
		USART_Cmd(USART1, ENABLE);																													//Start USART1

  	LCD_Initialize();
		
//*****************************************Interesujaca nas informacja z GPS******************************************************//		
//**********************np. $GPGGA,112057.670,5224.2076,N,02054.7170,E,1,08,1.0,52.1,M,33.0,M,,0000*62****************************//
//********************************************************************************************************************************//
//*****************************************LCD        52o24'12.456"N             *************************************************//
//*****************************************LCD				02054.7170,E								************************************************//

		LCD_WriteTextXY("Czekaj",8,0);	
  	while (1)
	{

		while( ( temp[0] = getch() ) != '$');											//Jesli pierwszy znak '$' to			
		for(i = 0; i < 5 ; i++)																		
			temp[i] = getch();																			//Odczytaj kolejnych 5
		if( strncmp(temp, GPGGA, 5) )															//sprawdz czy komenda CPGGA
		{
			for(i = 0; i < 14 ; i++)																//Jesli tak - pomin godzine i niepotrzebne nam informacje
				temp[0] = getch();

			for(i = 0; i < 11; i++)																	//Zapisz do N[] szerokosc geograficzna
				N[i] = getch();
			N[i+1] = '\0';																				
	
			temp[0] = getch();																			//Pomin ","
	
			for(i = 0; i < 12; i++)																	//Zapisz do E[] dlugosc geograficzna
				E[i] = getch();
			E[i+1] = '\0';
			
																			
			if(N[10] == 'N'||N[10]=='S')														//Jesli szerokosc geograficzna prawidlowo odczytana
			{																												//Jesli jestesmy nad rownikiem to mamy szerokosc polnocna(N)
																															//Ponizej rownika jest szerokosc poludniowa (S)
				
				
				
				PrzeliczN();																					//Zamien format N[] z DM na DMS i przygotuj N[] do wyswietlenia	  	
				//LCD_WriteCommand(HD44780_CLEAR);
			LCD_WriteTextXY((unsigned char*)N,3,0);																//Wyswietl N[];
			}
																				
			if(E[11] == 'E'||E[11] == 'W')													//Jesli dlugosc geograficzna odczytana poprawnie
																															//Na wschod od poludnika Greenwich jest dlugosc wschodnia(E)
																															//Na zachod od poludnika Greenwich jest dlugosc zachodnia(W)
				LCD_WriteTextXY((unsigned char*)E,4,1);																		//WyswietlE[] w drugiej lini 
		}		  
	}
}


//Malo wydajna funkcja :)-Zmiana stringa N[] na float, wykonanuje mnozenie minut szerokosci geograficznej systemu DM przez 0.6 aby otrzymac
//DMS i z powrotem zamienia float na string juz w formacie DMS
//Ponizsza funkcja ma za zadanie zmienic format DM na DMS oraz ladnie sformatowac wynik do wyswietlenia.
//
void PrzeliczN(void)																															
{
				for(i=2;i<4;i++)
				Nm[i-2]=N[i];																																//Odczytaj wartosc minut szerokosci geograficznej i zapisz do Nm[]
				Nm[2]=0x27;
				
				for(i=5;i<9;i++)																														//Odczytaj wartosc sekund szerokosci geograficznej i zapisz do Ns[]
				Ns[i-5]=N[i];
		
				N[2]=0xDF;																																	//Znak stopni
				
				for (i=0;i<3;i++)
				N[i+3]=Nm[i];
				
				fLiczba=(((Ns[0]-48)*1000)+((Ns[1]-48)*100)+((Ns[2]-48)*10)+(Ns[3]-48))*6;	//Zamien stringa na float i pomnoz * 6
																																										//"-48" poniewaz zamieniamy z char-a na cyfre 
				N[6]=(char) floor(fLiczba/10000)+48;																				//Spowrotem zmiana float na string
				fLiczba-=(N[6]-48)*10000;																										//oraz sformatowanie N[] do postaci jaka ma byc wyswietlona
				N[7]=(char) floor(fLiczba/1000)+48;
				fLiczba-=(N[7]-48)*1000;
				N[8]='.';
				N[9]=(char) floor(fLiczba/100)+48;
				fLiczba-=(N[9]-48)*100;
				N[10]=(char) floor(fLiczba/10)+48;
				fLiczba-=(N[10]-48)*10;
				N[11]=(char)floor(fLiczba)+48;
				N[12]=0x22;
				N[13]='N';
				N[14]='\0';																																	//Znacznik konca tekstu
				
	
}

//Konfiguracja sygnalow taktujacych
void RCC_Conf(void)
{  
  	ErrorStatus HSEStartUpStatus; 

  	// Reset ustawien RCC
  	RCC_DeInit();

  	// Wlacz HSE
  	RCC_HSEConfig(RCC_HSE_ON);

  	// Czekaj za HSE bedzie gotowy
  	HSEStartUpStatus = RCC_WaitForHSEStartUp();

  	if(HSEStartUpStatus == SUCCESS)
  		{
    	FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    	// zwloka dla pamieci Flash
    	FLASH_SetLatency(FLASH_Latency_2);
 	
   		// HCLK = SYSCLK=72MHz
    	RCC_HCLKConfig(RCC_SYSCLK_Div1); 
  
    	// PCLK2 = HCLK=72MHz
    	RCC_PCLK2Config(RCC_HCLK_Div1); 

    	// PCLK1 = HCLK/2=36MHz
    	RCC_PCLK1Config(RCC_HCLK_Div2);

    	// PLLCLK = 8MHz * 9 = 72 MHz
    	RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);

    	// Wlacz PLL 
    	RCC_PLLCmd(ENABLE);

    	// Czekaj az PLL poprawnie sie uruchomi
    	while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);

    	// PLL bedzie zrodlem sygnalu zegarowego
    	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    	// Czekaj az PLL bedzie sygnalem zegarowym systemu
    	while(RCC_GetSYSCLKSource() != 0x08);

  		// Wlacz taktowanie GPIOA
  		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 | RCC_APB2Periph_AFIO, ENABLE);
			RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
  	}
}

void NVIC_Conf(void)
{
	#ifdef  VECT_TAB_RAM  
  		// Jezeli tablica wektorow w RAM, to ustaw jej adres na 0x20000000
  		NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
	#else  // VECT_TAB_FLASH
  		// W przeciwnym wypadku ustaw na 0x08000000
  		NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
	#endif
}



